SET STATISTICS IO ON
go
sp_helpindex charge
SELECT M.FirstName + ' ' + M.Lastname AS Member,
		C.Charge_amt AS ChargeAmount, 
		C.Charge_dt AS ChargeDate
FROM Member AS M (index = 0)
	JOIN Charge AS C (index = 0)
		ON M.Member_NO = C.Member_No
WHERE C.Provider_No > 255 AND M.LastName < 'N'

--30 Seconds to Execute
--387184 row(s) affected
-- Charge: 5443
-- Member: 143

--Indexes on Join Cols
CREATE UNIQUE INDEX MemberJoin ON Member(Member_no) -- PK
CREATE INDEX ChargeJoin ON Charge(Member_no) -- FK
go

--Indexes on SARGs
CREATE INDEX MemberSARG ON Member(LastName) 
CREATE INDEX ChargeSARG ON Charge(Provider_no) 
go

SELECT M.FirstName + ' ' + M.Lastname AS Member,
		C.Charge_amt AS ChargeAmount 
FROM Member AS M 
	JOIN Charge AS C 
		ON M.Member_NO = C.Member_No
WHERE C.Provider_No > 255 AND M.LastName < 'N'
go
-- Nothing is selective enough....
-- Same Rows
-- Member: 5428
-- Charge: 22

--Combo Index - Priority to the Join Condition
CREATE UNIQUE INDEX MemberJoinCombo ON Member(Member_no, LastName) -- PK
CREATE INDEX ChargeJoinCombo ON Charge(Member_no, Provider_no) -- FK
go

--Combo Index - Priority to the SARG Condition
CREATE INDEX MemberSARGCombo ON Member(LastName, Member_no) 
CREATE INDEX ChargeSARGCombo ON Charge(Provider_no, Member_No) 
go

SELECT M.FirstName + ' ' + M.Lastname AS Member,
		C.Charge_amt AS ChargeAmount, 
		C.Charge_dt AS ChargeDate
FROM Member AS M 
	JOIN Charge AS C 
		ON M.Member_NO = C.Member_No
WHERE C.Provider_No > 255 AND M.LastName < 'N'
go

--Still not working? 
	-- Probably not if the query is not very selective!

--Can you cover either query?

-- Try Covering one or both of the queries
	-- Don't forget to drop the un-used indexes

-- About 2mins to build all 4 (TS Machine)
--Combo Covering Index - Priority to the Join Condition
CREATE UNIQUE INDEX MemberJoinComboCovering ON Member(Member_no, LastName, FirstName) -- PK
CREATE INDEX ChargeJoinComboCovering ON Charge(Member_no, Provider_no, Charge_amt, Charge_Dt) -- FK
go

--Combo Covering Index - Priority to the SARG Condition
CREATE INDEX MemberSARGComboCovering ON Member(LastName, Member_no, FirstName) 
CREATE INDEX ChargeSARGComboCovering ON Charge(Provider_no, Member_No, Charge_amt, Charge_Dt) 
go

-- Ctrl+L to see the estimate in perf.
SELECT M.FirstName + ' ' + M.Lastname AS Member,
		C.Charge_amt AS ChargeAmount, 
		C.Charge_dt AS ChargeDate
FROM Member AS M (index = 0)
	JOIN Charge AS C (index = 0)
		ON M.Member_NO = C.Member_No
WHERE C.Provider_No > 255 AND M.LastName < 'N'
go
SELECT M.FirstName + ' ' + M.Lastname AS Member,
		C.Charge_amt AS ChargeAmount, 
		C.Charge_dt AS ChargeDate
FROM Member AS M 
	JOIN Charge AS C 
		ON M.Member_NO = C.Member_No
WHERE C.Provider_No > 255 AND M.LastName < 'N'
go